//
//  RA20.H
//
//      RemoteAccess version 2.00 data structure.
//
//      Copyright (c) 1993 Tommy Wu.
//      All Rights Reserved.
//
#if !defined(__RA20_H)

#define __RA20_H

#ifdef __cplusplus
extern "C" {
#endif

                                                    // AskType
#define         RA2_AskType_Yes             0       // Yes
#define         RA2_AskType_No              1       // No
#define         RA2_AskType_Ask             2       // Ask
#define         RA2_AskType_Only            3       // Only


                                                    // VideoType
#define         RA2_VideoType_Auto          0       // Auto
#define         RA2_VideoType_Short         1       // Short
#define         RA2_VideoType_Long          2       // Long

                                                    // MsgType
#define         RA2_MsgType_LocalMail       0       // LocalMail
#define         RA2_MsgType_NetMail         1       // NetMail
#define         RA2_MsgType_EchoMail        2       // EchoMail

                                                    // MsgKindsType
#define         RA2_MsgKindsType_Both       0       // Both
#define         RA2_MsgKindsType_Private    1       // Private
#define         RA2_MsgKindsType_Public     2       // Public
#define         RA2_MsgKindsType_ROnly      3       // ROnly
#define         RA2_MsgKindsType_NoReply    4       // NoReply

                                                    // OrphanType
#define         RA2_OrphanType_Ignore       0       // Ignore
#define         RA2_OrphanType_Create       1       // Create
#define         RA2_OrphanType_Kill         2       // Kill

//
//  FlagType       = array[1..4] of Byte;
//  Time           = String[5];
//  Date           = String[8];
//  LongDate       = String[9];
//  ByteArray32    = Array[1..32] of Byte;
//

typedef struct {
    unsigned int        Zone,
                        Net,
                        Node,
                        Point;
} RA2T_netaddress;

typedef struct {
    unsigned int        Security,
                        Ltime,
                        L300,
                        L1200,
                        L2400,
                        L4800,
                        L7200,
                        L9600,
                        L12000,
                        L14400,
                        L16800,
                        L19200,
                        L38400,
                        Llocal,
                        RatioNum,
                        RatioK;
    unsigned char       PerMinCost[6];  // Real number, size not exist in C/C++
    unsigned char       FreeSpace[42];
} RA2T_limits;

typedef struct {
    unsigned char       Name[36],
                        Handle[36];
    unsigned char       Line;
    unsigned int        Baud;
    unsigned char       City[26];
    unsigned char       Status,
                        Attribute;
//
//                   { Status byte - 0 : Browsing (in a menu)
//                                   1 : Uploading/downloading
//                                   2 : Reading/posting messages
//                                   3 : In a door/external utility
//                                   4 : Chatting with sysop
//                                   5 : Answering questionnaire
//                                   6 : RTC
//                                   7 : New user logon
//                                 255 : User-defined - display StatDesc
//
//                     Attribute   - Bit 0 : Hidden
//                                       1 : Wants chat
//                                       2 : Reserved for RANETMGR
//                                       3 : Do not disturb flag
//                                       6 : Ready (0=busy) }
//
    unsigned char       StatDesc[11];
    unsigned char       FreeSpace[98];
    unsigned int        NoCalls;
} RA2T_useron;

typedef struct {
    unsigned char       Name[13];
    long int            Size,
                        CRC32;
    unsigned char       Uploader[36];
    long int            UploadDate,
                        FileDate,
                        LastDL;
    unsigned int        TimesDL;
    unsigned char       Attrib;
//
//          {Attrib - Bit 0 : Deleted
//                        1 : Unlisted
//                        2 : Free (don't adjust ratio) - Does NOT affect "Cost"
//                        3 : Not available (don't allow downloads)
//                        4 : Locked (no kill)
//                        5 : Missing/offline
//                        6 : No time restrictions - always allow DL
//          }
//
    unsigned char       Password[16];
    unsigned char       KeyWord[5][16];
    unsigned int        Cost;
    long int            LongDescPtr;
    unsigned char       FreeSpace[20];
} RA2T_fileshdr;

typedef struct {
    unsigned char       Name[13];
    long int            UploadDate;
    long int            KeyWordCRC[5];
    long int            LongDescPtr;
} RA2T_filesidx;

typedef struct {
    long int            NameCRC32;
    long int            HandleCRC32;
} RA2T_usersidx;

//  COMBINEDrecord = array[1..200] of Word;

typedef struct {
    unsigned char       Name[36],
                        Location[26],
                        Organisation[51],
                        Address1[51],
                        Address2[51],
                        Address3[51],
                        Handle[36],
                        Comment[81];
    long int            PasswordCRC;
    unsigned char       DataPhone[16],
                        VoicePhone[16],
                        LastTime[6],
                        LastDate[9];
    unsigned char       Attribute;
//
//                      { Bit 0 : Deleted
//                            1 : Clear screen
//                            2 : More prompt
//                            3 : ANSI
//                            4 : No-kill
//                            5 : Xfer priority
//                            6 : Full screen msg editor
//                            7 : Quiet mode }
//
    unsigned char       Attribute2;
//
//                      { Bit 0 : Hot-keys
//                            1 : AVT/0
//                            2 : Full screen message viewer
//                            3 : Hidden from userlist
//                            4 : Page priority
//                            5 : No echomail in mailbox scan
//                            6 : Guest account
//                            7 : Post bill enabled }
//
    unsigned char       Flags[4];
    long int            Credit,
                        Pending;
    unsigned int        MsgsPosted,
                        Security;
    long int            LastRead,
                        NoCalls,
                        Uploads,
                        Downloads,
                        UploadsK,
                        DownloadsK,
                        TodayK;
    int                 Elapsed;
    unsigned int        ScreenLength;
    unsigned char       LastPwdChange;
    unsigned int        Group;
    unsigned int        CombinedInfo[200];
    unsigned char       FirstDate[9],
                        BirthDate[9],
                        SubDate[9];
    unsigned char       ScreenWidth,
                        Language,
                        DateFormat;
    unsigned char       ForwardTo[36];
    unsigned int        MsgArea,
                        FileArea;
    char                DefaultProtocol;
    unsigned int        FileGroup;
    unsigned char       LastDOBCheck,
                        Sex;
    long int            XIrecord;
    unsigned int        MsgGroup;
    unsigned char       FreeSpace[48];
} RA2T_users;

typedef struct {
    unsigned char       FreeSpcae[200];
} RA2T_usersxi;

typedef struct {
    unsigned int        AreaNum;
    unsigned char       Name[41];
    unsigned int        Security;
    unsigned char       Flags[4],
                        NotFlagsMask[4];
    unsigned char       FreeSpace[100];
} RA2T_group;

typedef struct {
    unsigned char       Unused[4];
    unsigned char       Name[41];
    unsigned char       Attrib;
//
//                      { Bit 0 : Include in new files scan
//                            1 : Include in upload dupe scan
//                            2 : Permit long descriptions
//                            3 : Area is on CD-ROM
//                            4 : All files are FREE
//                            5 : Allow DLs not in FDB
//                            6 : Allow users to password uploads
//                            7 : Scan uploads }
//
    unsigned char       FilePath[41];
    unsigned int        KillDaysDL,
                        KillDaysFD;
    unsigned char       Password[16];
    unsigned int        MoveArea;
    unsigned char       Age,
                        ConvertExt;
    unsigned int        Group;
    unsigned char       Attrib2;
//
//                      { Bit 0 : Include in all groups }
//
    unsigned int        DefCost,
                        UploadArea,
                        UploadSecurity;
    unsigned char       UploadFlags[4],
                        UploadNotFlags[4];
    unsigned int        Security;
    unsigned char       Flags[4],
                        NotFlags[4];
    unsigned int        ListSecurity;
    unsigned char       ListFlags[4],
                        ListNotFlags[4];
    unsigned int        AltGroup[3];
    unsigned char       Device;
    unsigned char       FreeSpace[13];
} RA2T_files;

typedef struct {
    long int            TotalCalls;
    unsigned char       LastCaller[36];
    unsigned char       ExtraSpace[128];
} RA2T_sysinfo;

typedef struct {
    unsigned char       StartDate[9];
    unsigned int        BusyPerHour[24];
    unsigned int        BusyPerDay[7];
} RA2T_timelog;

typedef struct {
    unsigned char       Status;
//
//                          { 0=Deleted 1=Enabled 2=Disabled }
//
    unsigned char       StartTime[6];
    unsigned char       ErrorLevel,
                        Days;
    unsigned char       Forced;
    unsigned char       LastTimeRun[9];
} RA2T_event;

typedef struct {
    unsigned int        Baud;
    RA2T_sysinfo        SysInfo;
    RA2T_timelog        TimeLogInfo;
    RA2T_users          UserInfo;
    RA2T_event          EventInfo;
    unsigned char       NetMailEntered,
                        EchoMailEntered;
    unsigned char       LoginTime[6];
    unsigned char       LoginDate[9];
    unsigned int        TimeLimit;
    long int            LoginSec;
    int                 UserRecord;
    unsigned int        ReadThru,
                        NumberPages,
                        DownloadLimit;
    unsigned char       TimeOfCreation[6];
    long int            LogonPasswordCRC;
    unsigned char       WantChat;
    int                 DeductedTime;
    unsigned char       MenuStack[50][9];
    unsigned char       MenuStackPointer;
    RA2T_usersxi        UserXIinfo;
    unsigned char       ErrorFreeConnect,
                        SysopNext,
                        EMSI_Session;
    unsigned char       EMSI_Crtdef[41],
                        EMSI_Protocols[41],
                        EMSI_Capabilities[41],
                        EMSI_Requests[41],
                        EMSI_Software[41];
    unsigned char       Hold_Attr1,
                        Hold_Attr2,
                        Hold_Len;
    unsigned char       PageReason[81];
    unsigned char       StatusLine;
    unsigned char       ExtraSpace[99];
} RA2T_exitinfo;

#ifdef __cplusplus
}
#endif

#endif
