//
//  RAUSM.H
//
//      RemoteAccess User Security Manager.
//      Copyright (c) 1993 Tommy Wu. All rights reserved.
//
#if !defined(__RAUSM_H__)
#define __RAUSM_H__

#include <stdio.h>
#include <stdlib.h>

typedef struct {
    unsigned int    Security;
    long int        Credit;
} SecData;

typedef struct _list {
    char            *SourceName;
    char            *TargetName;
    struct _list    *Next;
} SortList;

typedef struct {
    int             userno;
    unsigned int    no;
} USort;

typedef struct {
    int             userno;
    long int        no;
} LSort;

typedef struct _hdata {
    char            *name;
    struct _hdata   *next;
} Hidden;

char *strp2c(char *p);
void ReadCTL(char *path);
void _Err_Handler(char *file, int line, char *date, char *time, int errlevel);

extern FILE         *logfp;
extern char         UserBbsPath[_MAX_PATH];
extern char         ListName[_MAX_PATH];
extern int          ReportOnly;
extern long int     UploadCredit;
extern long int     UploadKCredit;
extern long int     DownloadCredit;
extern long int     DownloadKCredit;
extern long int     MessageCredit;
extern long int     CallOnCredit;
extern long int     SysOpCredit;
extern long int     LoginDayCredit;
extern long int     BaseCredit;
extern char         UserFlag[4];
extern unsigned int MaxSecurity;
extern unsigned int MinSecurity;
extern int          SecCount;
extern SecData      Security[200];
extern Hidden       *HiddenHead;
extern SortList     *SortHead;

#define ERR_EXIT(i)    _Err_Handler(__FILE__, __LINE__, __DATE__, __TIME__, i)
#define Version     "1.20"

#endif
